/* 29/01/12	version ver 2						*/
/* Changes:								*/
/*	Hack ad1940 code base						*/
/* 									*/
/* known Issues: All of them						*/
/* use of arrays is massively code inefficient - fix needed             */



#include "delay.h"
#include "dig_cross.h"
#include "SigmaStudioFW.h"
#include <math.h>
#include "xc.h"
#include <plib.h>
#include <p32mx450f256h.h>



/* Make this global to this function to save RAM */
int Data_Counter = 0;
long int Fixed_Point;
static unsigned char	Read_Data_Array[6];						/* Array used to hold data read during debug process */


/****************************************************************************************/
/* write 8 bits to DSP using SPI interface                                              */
/* This assumes that CSEL is already active 						*/
/****************************************************************************************/
void Write_8_Bits(char Data_Word)
{
      SpiChnPutC (Temp_SPI_Address, Data_Word);               // send Write OpCode
      getcSPI1();                                           // empty read buffer
}

/****************************************************************************************/
/* write 16 bits to DSP using SPI interface                                              */
/* This assumes that CSEL is already active 						*/
/****************************************************************************************/
void Write_16_Bits(int Data_Word)
{
    unsigned char Data_To_Write;

    Data_To_Write = (unsigned char)((Data_Word>>8) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer

    Data_To_Write = (unsigned char)((Data_Word) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer
}

/****************************************************************************************/
/* write 32 bits to DSP using SPI interface                                              */
/* This assumes that CSEL is already active 						*/
/****************************************************************************************/
void Write_32_Bits(int Data_Word)
{
    unsigned char Data_To_Write;
    Data_To_Write = (unsigned char)((Data_Word>>24) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer

    Data_To_Write = (unsigned char)((Data_Word >>16) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer

    Data_To_Write = (unsigned char)((Data_Word>>8) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer

    Data_To_Write = (unsigned char)((Data_Word ) & 0x000000ff);
    SpiChnPutC (Temp_SPI_Address, Data_To_Write );             // send Write OpCode
    getcSPI1();                                             // empty read buffer
}


/****************************************************************************************/
/* Input																				*/
/*		devAddress: 		the SPI Address to be read from								*/
/*		Address_to_Read: 	the Address in RAM to be read 								*/
/*		Number_of_Words: 	the number of words											*/
/*		*ptr_to_Data: 		pointer to an array of CHAR in RAM for read data			*/
/*	Output																				*/
/*		Changes data pointed to by *prt_to_Data											*/
/*	Returns																				*/
/*		none																			*/
/****************************************************************************************/
void ReadSPI(char devAddress, int Address_to_Read, int Number_of_Words, unsigned char *ptr_to_Data)
{
int Data_Counter;

CselLow;  							/* Set CSEL Low */

	Write_SPI_Addr((char)devAddress, Read_From_SPI); 	/* Address the Device */
	Write_16_Bits(Address_to_Read);    			/* Provide the address of data sought */

	for (Data_Counter = 0; Data_Counter < Number_of_Words; Data_Counter++)
		{ 
                *ptr_to_Data = ReadSPI1();
		ptr_to_Data++;
		}

CselHigh;  											/* Set CSEL High */

}



/* Initialise ADCs  */
/* not using SPI control of these - so simple hold in reset till the clocks are stable */
/* the CS4398 in particular is pretty fussy about this */
void Init_ADC(void)
{
SetDACReset;
DelayMs(DAC_Reset_Time);		/* Hold ADC and DAC in reset for a defined period of time */
ClearDACReset;
}



/*
Write_PGA2320() takes a given bands required attenuation and programs the volume control IC for this

Band:
	This code assumes there is one attenuator with 8 bits for l/R
Attenuation:
	- unsigned char 
	- unsigned char
How the hell does this work?
	- The PGA2320 gain is defined by left and right input data, of 8 bits per channel
	- Gain = 31.5 - (0.5*(255-n)) dB

*/
void Write_PGA2320(unsigned char atten1, unsigned char atten2)
{
char loop;

CselLowPGA2320;
Write_8_Bits (atten1);
Write_8_Bits (atten2);
CselHighPGA2320;
}



